//#define KeyPort P2
#define KeyNull 0x10

unsigned char KeyScan(void);
unsigned char KeyScan_get_key(void);
unsigned char KeyScan_check_key(void);
unsigned char KeyScan_get_byte(void);
unsigned int  KeyScan_get_word(void);
unsigned int  KeyScan_get_integer(void);
unsigned char KeyScan_convert(unsigned char key,char *s);

//char buf[]="048C159D26AE37BF";


unsigned char KeyScan(void)
{
  unsigned char scanline=0x80;
  unsigned char col=0,row,key=0x10;
  unsigned char rowkey;
 for(col=0;col<4;col++){ 
  KeyPort=~scanline;
   rowkey= ~KeyPort & 0x0f;
  if(rowkey != 0)					
		{	if(rowkey == 0x01)     	row=3;	// Y0CQU
			else if(rowkey == 0x02)	row=2;	// Y1CQU
			else if(rowkey == 0x04)	row=1;	// Y2CQU
			else if(rowkey == 0x08)	row=0;	// Y3CQU
			key = 4 * col + row;			
			while(rowkey != 0)		
			rowkey= ~KeyPort & 0x0f;
			return key;
		}
		scanline>>=1;									
 } 
  return KeyNull;
} 
unsigned char KeyScan_get_key(void){

	unsigned char key;
	while((key=KeyScan())==KeyNull);
	return key;
}
unsigned char KeyScan_get_byte(void)
{
return(KeyScan_get_key()*16+KeyScan_get_key());
}

unsigned int KeyScan_get_word(void)
{
return(KeyScan_get_byte()*256+KeyScan_get_byte());
}
unsigned char KeyScan_check_key(void){
	unsigned char key;
	key=KeyScan();
	if(key!=KeyNull)
	return key;
	else
	return KeyNull;
}
unsigned int KeyScan_get_integer(void)
{
unsigned int value=0;
unsigned char key;
while((key=KeyScan_get_key())<0x0A){
	value=value*10+key;
	}
return value;
}

unsigned char KeyScan_convert(unsigned char key,char *s){	
	unsigned char k;
	key&=0x0f;
	s+=key;
	key=*s;
	switch(key){
		case '0':
			k=0x00;
			break;
		case '1':
			k=0x01;
			break;
		case '2':
			k=0x02;
			break;
		case '3':
			k=0x03;
			break;
		case '4':
			k=0x04;
			break;
		case '5':
			k=0x05;
			break;
		case '6':
			k=0x06;
			break;
		case '7':
			k=0x07;
			break;
		case '8':
			k=0x08;
			break;
		case '9':
			k=0x09;
			break;
		case 'A':
			k=0x0a;
			break;
		case 'B':
			k=0x0b;
			break;
		case 'C':
			k=0x0c;
			break;
		case 'D':
			k=0x0d;
			break;
		case 'E':
			k=0x0e;
			break;
		case 'F':
			k=0x0f;
			break;											
	}
	return k;
}

    
  
